local revision = tonumber(("$Revision: 21308 $"):sub(12, -3))
if revision > Cartographer.revision then
	Cartographer.version = "r" .. revision
	Cartographer.revision = revision
	Cartographer.date = ("$Date: 2006-12-18 21:31:36 -0500 (Mon, 18 Dec 2006) $"):sub(8, 17)
end

local L = AceLibrary("AceLocale-2.2"):new("Cartographer-LookNFeel")

L:RegisterTranslations("enUS", function() return {
	["Look 'n' Feel"] = true,
	["Module which allows you to change the transparency, position, and scale of the world map."] = true,
	
	["Transparency"] = true,
	["Transparency of the World Map"] = true,
	
	["Overlay transparency"] = true,
	["Transparency of World Map overlays"] = true,
	
	["Scale"] = true,
	["Scale of the World Map"] = true,
	
	["Tooltip scale"] = true,
	["Scale of the World Map tooltip"] = true,
	
	["Shift-MouseWheel to change transparency"] = true,
	["Ctrl-MouseWheel to change scale"] = true,
	
	["Lock the World Map"] = true,
	
	["Close with escape"] = true,
	["Close the World Map when pressing the escape button"] = true,
	
	["Large player arrow"] = true,
	["Make the player's arrow on the World Map 1.5 times larger than normal"] = true,
	
	["Unlock World Map"] = true,
	["Lock World Map"] = true,
	["Note: holding Alt while locked will temporarily unlock the World Map."] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Look 'n' Feel"] = "모양",
	["Module which allows you to change the transparency, position, and scale of the world map."] = "세계 지도의 투명도, 위치 그리고 크기등을 변경합니다.",
	
	["Transparency"] = "투명도",
	["Transparency of the World Map"] = "세계 지도의 투명도를 설정합니다.",
	
	["Overlay transparency"] = "오버레이 투명도",
	["Transparency of World Map overlays"] = "세계 지도 오버레이의 투명도를 설정합니다.",
	
	["Scale"] = "크기",
	["Scale of the World Map"] = "세계 지도의 크기를 설정합니다.",
	
	["Tooltip scale"] = "툴팁 크기",
	["Scale of the World Map tooltip"] = "세계 지도의 툴팁 크기를 설정합니다.",
	
	["Shift-MouseWheel to change transparency"] = "Shift-스크롤 : 투명도 변경",
	["Ctrl-MouseWheel to change scale"] = "Ctrl-스크롤 : 크기 변경",
	
	["Lock the World Map"] = "세계 지도의 위치를 잠금니다.",
	
	["Close with escape"] = "Esc 닫기",
	["Close the World Map when pressing the escape button"] = "Esc 버튼을 누루면 세계 지도를 닫습니다.",
	
	["Large player arrow"] = "플레이어 위치 크게",
	["Make the player's arrow on the World Map 1.5 times larger than normal"] = "1.5배 정도 플레이어 위치를 좀더 크게 표시합니다.",
	
	["Unlock World Map"] = "세계 지도 이동",
	["Lock World Map"] = "세계 지도 고정",
	["Note: holding Alt while locked will temporarily unlock the World Map."] = "노트: 고정된 세계 지도의 임시 지역 이동은 Alt키를 누룬 상태에서 열수 있습니다.",
} end)

L:RegisterTranslations("deDE", function() return {
	["Look 'n' Feel"] = "Look 'n' Feel",
	["Module which allows you to change the transparency, position, and scale of the world map."] = "Modul welches dir erlaubt die Transparenz, Position, und Skalierung der Weltkarte zu ändern.",
	
	["Transparency"] = "Transparenz",
	["Transparency of the World Map"] = "Transparenz der Weltkarte",
	
	["Overlay transparency"] = "Overlay Transparenz",
	["Transparency of World Map overlays"] = "Transparent des Weltkarten Hintergrunds",
	
	["Scale"] = "Skalierung",
	["Scale of the World Map"] = "Skalierung der Weltkarte",
	
	["Tooltip scale"] = "Tooltip Skalierung",
	["Scale of the World Map tooltip"] = "Skalierung des Weltkarten Tooltips",
	
	["Shift-MouseWheel to change transparency"] = "Shift+Mausrad um Transparanz zu ändern",
	["Ctrl-MouseWheel to change scale"] = "Strg+Mausrad um Skalirung zu ändern",
	
	["Lock the World Map"] = "Sperrt die Weltkarte",
	
	["Close with escape"] = "Schliessen mit Escape",
	["Close the World Map when pressing the escape button"] = "Schliesst die Weltkarte mit der Escape Taste",
	
	["Large player arrow"] = "Großer Spieler Pfeil",
	["Make the player's arrow on the World Map 1.5 times larger than normal"] = "Macht den Spieler Pfeil auf der Weltkarte 1.5 mal größer als normal",
	
	["Unlock World Map"] = "Entsperre die Weltkarte",
	["Lock World Map"] = "Sperr die Weltkarte",
	["Note: holding Alt while locked will temporarily unlock the World Map."] = "Hinweis: Halten der Alt-Taste solange gesperrt wird kurzzeitig die Weltkarte entsperren.",
} end)

L:RegisterTranslations("frFR", function() return {
	["Look 'n' Feel"] = "Affichage et comportement",
	["Module which allows you to change the transparency, position, and scale of the world map."] = "Module permettant la personnalisation de la transparence, la position et la taille de la carte du monde.",

	["Transparency"] = "Transparence",
	["Transparency of the World Map"] = "Détermine la transparence de la carte du monde.",

	["Overlay transparency"] = "Transparence sur-impression",
	["Transparency of World Map overlays"] = "Détermine la transparence des textes en sur-impression de la carte du monde.",

	["Scale"] = "Taille",
	["Scale of the World Map"] = "Détermine la taille de la carte du monde.",

	["Tooltip scale"] = "Taille des infobulles",
	["Scale of the World Map tooltip"] = "Détermine la taille des infobulles de la carte du monde.",

	["Shift-MouseWheel to change transparency"] = "Shift-molette pour changer la transparence",
	["Ctrl-MouseWheel to change scale"] = "Ctrl-molette pour changer la taille",

	["Lock the World Map"] = "Verrouille la carte du monde.",

	["Close with escape"] = "Fermer avec Echappement",
	["Close the World Map when pressing the escape button"] = "Ferme la carte du monde en appuyant sur la touche Echappement.",

	["Large player arrow"] = "Grosse flèche joueur",
	["Make the player's arrow on the World Map 1.5 times larger than normal"] = "Rend la flèche du joueur sur la carte du monde 1,5 fois plus grosse que la normale.",

	["Unlock World Map"] = "Déverrouiller la carte du monde",
	["Lock World Map"] = "Verrouiller la carte du monde",
	["Note: holding Alt while locked will temporarily unlock the World Map."] = "Note : maintenir la touche Alt enfoncée quand la carte est verrouillée déverrouillera temporairement la carte.",
} end)

L:RegisterTranslations("esES", function() return {
	["Look 'n' Feel"] = "Apariencia",
	["Module which allows you to change the transparency, position, and scale of the world map."] = "M\195\179dulo que te permite cambiar la transparencia, posici\195\179n y escala del mapa del mundo",
	
	["Transparency"] = "Transparencia",
	["Transparency of the World Map"] = "Transparencia del Mapa del Mundo",
	
	["Overlay transparency"] = "Transparencia de los Superpuestos",
	["Transparency of World Map overlays"] = "Transparencia de los superpuestos del Mapa del Mundo",
	
	["Scale"] = "Escala",
	["Scale of the World Map"] = "Escala del Mapa del Mundo",
	
	["Tooltip scale"] = "Escala del Tooltip",
	["Scale of the World Map tooltip"] = "Escala del tooltip del Mapa del Mundo",
	
	["Shift-MouseWheel to change transparency"] = "May\195\186sculas+RuedaDelRat\195\179n para cambiar transparencia",
	["Ctrl-MouseWheel to change scale"] = "Ctrl+RuedaDelRat\195\179n para cambiar la escala",
	
	["Lock the World Map"] = "Bloquear el Mapa del Mundo",

	["Close with escape"] = "Cerrar con Escape",
	["Close the World Map when pressing the escape button"] = "Cierrar el Mapa del Mundo cuando se presiona la tecla Escape",
	
	["Large player arrow"] = "Flecha del jugador grande",
	["Make the player's arrow on the World Map 1.5 times larger than normal"] = "Hace que la flecha del jugador en el Mapa del Mundo sea 1.5 veces m\195\161s grande de lo normal",
	
	["Unlock World Map"] = "Desbloquear Mapa del Mundo",
	["Lock World Map"] = "Bloquear Mapa del Mundo",
	["Note: holding Alt while locked will temporarily unlock the World Map."] = "Nota: presionando Alt mientras est\195\161 bloqueado desbloquear\195\161 temporalmente el Mapa del Mundo",
} end)

Cartographer_LookNFeel = Cartographer:NewModule("LookNFeel", "AceEvent-2.0", "AceHook-2.1")

local _G = getfenv(0)

local tmp = {}
local fake_ipairs = function(...)
	for k in pairs(tmp) do
		tmp[k] = nil
	end
	for i = 1, select('#', ...) do
		tmp[i] = select(i, ...)
	end
	return ipairs(tmp)
end

function Cartographer_LookNFeel:OnInitialize()
	self.db = Cartographer:AcquireDBNamespace("LookNFeel")
	self.name = L["Look 'n' Feel"]
	self.title = L["Look 'n' Feel"]
	
	Cartographer:RegisterDefaults("LookNFeel", "profile", {
		alpha = 0.8,
		overlayAlpha = 1,
		scale = 0.75,
		ttScale = 1,
		locked = false,
		useEscape = true,
		largePlayer = true,
	})
	
	Cartographer.options.args.LookNFeel = {
		name = L["Look 'n' Feel"],
		desc = L["Module which allows you to change the transparency, position, and scale of the world map."],
		type = 'group',
		args = {
			alpha = {
				name = L["Transparency"],
				desc = L["Transparency of the World Map"],
				type = 'range',
				min = 0,
				max = 1,
				step = 0.05,
				isPercent = true,
				get = "GetAlpha",
				set = "SetAlpha",
			},
			overlayAlpha = {
				name = L["Overlay transparency"],
				desc = L["Transparency of World Map overlays"],
				type = 'range',
				min = 0.25,
				max = 1,
				step = 0.05,
				isPercent = true,
				get = "GetOverlayAlpha",
				set = "SetOverlayAlpha",
			},
			scale = {
				name = L["Scale"],
				desc = L["Scale of the World Map"],
				type = 'range',
				min = 0.2,
				max = 1,
				step = 0.05,
				isPercent = true,
				get = "GetScale",
				set = "SetScale",
			},
			ttScale = {
				name = L["Tooltip scale"],
				desc = L["Scale of the World Map tooltip"],
				type = 'range',
				min = 0.2,
				max = 2,
				step = 0.05,
				isPercent = true,
				get = "GetTooltipScale",
				set = "SetTooltipScale",
			},
			lock = {
				name = LOCK or "Lock",
				desc = L["Lock the World Map"],
				type = 'toggle',
				get = "IsLocked",
				set = "ToggleLocked",
			},
			useEscape = {
				name = L["Close with escape"],
				desc = L["Close the World Map when pressing the escape button"],
				type = 'toggle',
				get = "IsUsingEscape",
				set = "ToggleUsingEscape",
			},
			largePlayer = {
				name = L["Large player arrow"],
				desc = L["Make the player's arrow on the World Map 1.5 times larger than normal"],
				type = 'toggle',
				get = "IsLargePlayerPOI",
				set = "ToggleLargePlayerPOI",
			},
			toggle = {
				name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Active"],
				desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
				type = "toggle",
				order = -1,
				get = function() return Cartographer:IsModuleActive(self) end,
				set = function() Cartographer:ToggleModuleActive(self) end
			},
		},
		handler = self,
	}
	
	local orig = WorldMapFrame:GetScript("OnShow") or function() end
	WorldMapFrame:SetScript("OnShow", function()
		orig(this)
		
		if Cartographer:IsModuleActive(self) then
			this:SetScale(self.db.profile.scale)
			WorldMapTooltip:SetScale(self.db.profile.ttScale / self.db.profile.scale)
			this:SetWidth(1024)
			this:SetHeight(768)
		end
	end)
	
	for i = 1, 12 do
		local tex = _G["WorldMapDetailTile" .. i]
		local x = tex:GetLeft() - WorldMapDetailFrame:GetLeft()
		local y = tex:GetTop() - WorldMapDetailFrame:GetTop()
		tex:ClearAllPoints()
		tex:SetPoint("TOPLEFT", WorldMapDetailFrame, "TOPLEFT", x, y)
	end
end

local cities = {
	["ThunderBluff"] = true,
	["Ogrimmar"] = true,
	["TheExodar"] = true,
	["Darnassis"] = true,
	["Undercity"] = true,
	["Ironforge"] = true,
	["Stormwind"] = true,
	["SilvermoonCity"] = true,
	["ShattrathCity"] = true,
}

local lockButton
function Cartographer_LookNFeel:OnEnable()
	Cartographer:AddToMagnifyingGlass(L["Shift-MouseWheel to change transparency"])
	Cartographer:AddToMagnifyingGlass(L["Ctrl-MouseWheel to change scale"])
	UIPanelWindows["WorldMapFrame"] = nil
	WorldMapFrame:SetFrameStrata("HIGH")
	WorldMapFrame:EnableMouse(not self.db.profile.locked)
	WorldMapFrame:EnableMouseWheel(not self.db.profile.locked)
	WorldMapButton:EnableMouse(not self.db.profile.locked)
	WorldMapMagnifyingGlassButton:EnableMouse(not self.db.profile.locked)
	local button = Cartographer:GetInstanceWorldMapButton()
	if button then
		button:EnableMouse(not self.db.profile.locked)
	end
	self:RegisterEvent("Cartographer_RegisterInstanceWorldMapButton", function(frame)
		frame:EnableMouse(not self.db.profile.locked)
	end)
	WorldMapFrame:SetMovable(true)
	WorldMapFrame:RegisterForDrag("LeftButton")
	WorldMapFrame:SetScript("OnDragStart", function()
		this:SetWidth(1024)
		this:SetHeight(768)
		this:StartMoving()
	end)
	WorldMapFrame:SetScript("OnDragStop", function()
		this:StopMovingOrSizing()
		
		this:SetWidth(1024)
		this:SetHeight(768)
		local x,y = this:GetCenter()
		local z = UIParent:GetEffectiveScale() / 2 / this:GetScale()
		x = x - GetScreenWidth() * z
		y = y - GetScreenHeight() * z
		self.db.profile.x = x
		self.db.profile.y = y
		this:ClearAllPoints()
		this:SetPoint("CENTER", "UIParent", "CENTER", x, y)
	end)
	WorldMapFrame:SetScript("OnMouseWheel", function()
		local up = (arg1 == 1)
		
		if IsControlKeyDown() then
			local scale = self:GetScale()
			if up then
				scale = scale + 0.1
				if scale > 1 then
					scale = 1
				end
			else
				scale = scale - 0.1
				if scale < 0.2 then
					scale = 0.2
				end
			end
			self:SetScale(scale)
		elseif IsShiftKeyDown() then
			local alpha = self:GetAlpha()
			if up then
				alpha = alpha + 0.1
				if alpha > 1 then
					alpha = 1
				end
			else
				alpha = alpha - 0.1
				if alpha < 0 then
					alpha = 0
				end
			end
			self:SetAlpha(alpha)
		end
	end)
	WorldMapFrame:SetResizable(true)
	WorldMapFrame:SetAlpha(self.db.profile.alpha)
	WorldMapFrame:SetScale(self.db.profile.scale)
	WorldMapTooltip:SetScale(self.db.profile.ttScale / self.db.profile.scale)
	WorldMapFrame:SetWidth(1024)
	WorldMapFrame:SetHeight(768)
	self.old_WorldMapFrame_OnKeyDown = WorldMapFrame:GetScript("OnKeyDown")
	WorldMapFrame:SetScript("OnKeyDown", nil)
	WorldMapFrame:StartMoving()
	WorldMapFrame:StopMovingOrSizing()
	WorldMapFrame:ClearAllPoints()
	WorldMapFrame:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.x or 0, self.db.profile.y or 0)
	BlackoutWorld:Hide()
	WorldMapTooltip:SetFrameLevel(WorldMapFrame:GetFrameLevel() + 3)
	self:SecureHook(WorldMapDetailFrame, "CreateTexture", "WorldMapDetailFrame_CreateTexture")
	self:RegisterEvent("Cartographer_ChangeZone")
	self:RegisterEvent("MODIFIER_STATE_CHANGED")
	self:SecureHook("WorldMapButton_OnUpdate")
	self:Hook("CloseSpecialWindows", true)
	if not self.overlayHolder then
		self.overlayHolder = CreateFrame("Frame", "CartographerLookNFeelOverlayHolder", WorldMapDetailFrame)
		self.overlayHolder:SetPoint("TOPLEFT", WorldMapDetailFrame, "TOPLEFT")
		self.overlayHolder:SetPoint("BOTTOMRIGHT", WorldMapDetailFrame, "BOTTOMRIGHT")
		self.overlayHolder:SetFrameLevel(WorldMapDetailFrame:GetFrameLevel())
	end
	self.overlayHolder:Show()
	
	self.overlayHolder:SetAlpha(self.db.profile.overlayAlpha)
	WorldMapButton:SetAlpha(self.db.profile.overlayAlpha)
	for i,v in fake_ipairs(WorldMapFrame:GetChildren()) do
		if v:GetName() and (v:GetName():find("^Cartographer") or v:GetName():find("^Tablet20Detached")) then
			v:SetAlpha(self.db.profile.overlayAlpha)
		end
	end
	if not self.playerModel then
		for _,v in fake_ipairs(WorldMapFrame:GetChildren()) do
			if v:GetFrameType() == "Model" and not v:GetName() then
				self.playerModel = v
				break
			end
		end
	end
	self.playerModel:SetAlpha(self.db.profile.overlayAlpha)
	
	if (GetCurrentMapZone() == 0 or cities[GetMapInfo()]) and self.db.profile.overlayAlpha > self.db.profile.alpha then
		WorldMapDetailFrame:SetAlpha(self.db.profile.overlayAlpha)
	else
		WorldMapDetailFrame:SetAlpha(self.db.profile.alpha)
	end
	
	for i = 1, 1000 do
		local texture = _G["WorldMapOverlay" .. i]
		if not texture then
			break
		end
		texture:SetParent(self.overlayHolder)
	end
	
	WorldMapButton:SetScript("OnEnter", function()
		WorldMapFrameAreaLabel:Show()
	end)
	local function f()
		if MouseIsOver(WorldMapButton) and not Cartographer:GetCurrentInstance() then
			local n = GetMouseFocus() and GetMouseFocus():GetName()
			if not n or not n:find("^Tablet20") then
				WorldMapFrameAreaLabel:Show()
				self:ScheduleEvent("Cartographer-LookNFeel-WorldMapButton-OnLeave", f, 0.25)
				return
			end
		end
		WorldMapFrameAreaLabel:Hide()
	end
	WorldMapButton:SetScript("OnLeave", f)
	if MouseIsOver(WorldMapButton) and not Cartographer:GetCurrentInstance() then
		WorldMapFrameAreaLabel:Show()
	else
		WorldMapFrameAreaLabel:Hide()
	end
	
	self.playerModel:SetModelScale(self.db.profile.largePlayer and 1.5 or 1)
	
	if not lockButton then
		lockButton = CreateFrame("CheckButton", "CartographerLookNFeelLockButton", WorldMapFrame)
		lockButton:SetWidth(15)
		lockButton:SetHeight(22)
		local tex = lockButton:CreateTexture()
		tex:SetTexture("Interface\\Buttons\\UI-Button-KeyRing")
		tex:SetTexCoord(0, 0.5625, 0, 0.609375)
		tex:SetAllPoints(lockButton)
		lockButton:SetNormalTexture(tex)
		local tex = lockButton:CreateTexture()
		tex:SetTexture("Interface\\Buttons\\UI-Button-KeyRing-Highlight")
		tex:SetTexCoord(0, 0.5625, 0, 0.609375)
		tex:SetAllPoints(lockButton)
		lockButton:SetHighlightTexture(tex)
		local tex = lockButton:CreateTexture()
		tex:SetTexture("Interface\\Buttons\\UI-Button-KeyRing-Down")
		tex:SetTexCoord(0, 0.5625, 0, 0.609375)
		tex:SetAllPoints(lockButton)
		lockButton:SetPushedTexture(tex)
		local tex = lockButton:CreateTexture()
		tex:SetTexture("Interface\\Buttons\\UI-Button-KeyRing-Down")
		tex:SetTexCoord(0, 0.5625, 0, 0.609375)
		tex:SetAllPoints(lockButton)
		lockButton:SetCheckedTexture(tex)
		
		lockButton:SetScript("OnEnter", function(this)
			GameTooltip_SetDefaultAnchor(GameTooltip, this)
			GameTooltip:SetText(self:IsLocked() and L["Unlock World Map"] or L["Lock World Map"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
			GameTooltip:AddLine(L["Note: holding Alt while locked will temporarily unlock the World Map."])
			GameTooltip:Show()
		end)
		lockButton:SetScript("OnLeave", function(this)
			GameTooltip:Hide()
		end)
		lockButton:SetScript("OnClick", function(this)
			self:ToggleLocked()
			this:SetChecked(self:IsLocked())
			this:GetScript("OnEnter")(this)
		end)
		lockButton:SetChecked(self:IsLocked())
	else
		lockButton:Show()
	end
	
	Cartographer:AddMapButton(lockButton, 2)
	
	if WorldMapFrame:IsShown() then
		ToggleWorldMap()
		ToggleWorldMap()
	end
	Cartographer:RefreshSideTablet()
end

function Cartographer_LookNFeel:OnDisable()
	Cartographer:RemoveMapButton(lockButton)
	lockButton:Hide()
	Cartographer:RemoveFromMagnifyingGlass(L["Shift-MouseWheel to change transparency"])
	Cartographer:RemoveFromMagnifyingGlass(L["Ctrl-MouseWheel to change scale"])
	UIPanelWindows["WorldMapFrame"] = { whileDead=1, area="full", pushable=0 }
	WorldMapFrame:SetFrameStrata("FULLSCREEN")
	WorldMapFrame:EnableMouse(false)
	WorldMapFrame:EnableMouseWheel(false)
	WorldMapButton:EnableMouse(true)
	WorldMapMagnifyingGlassButton:EnableMouse(true)
	WorldMapFrame:SetScript("OnDragStart", nil)
	WorldMapFrame:SetScript("OnDragStop", nil)
	WorldMapFrame:SetScript("OnMouseWheel", nil)
	WorldMapFrame:StartMoving()
	WorldMapFrame:StopMovingOrSizing()
	WorldMapFrame:SetScale(1)
	WorldMapFrame:SetAlpha(1)
	WorldMapTooltip:SetScale(1)
	WorldMapFrame:StartMoving()
	WorldMapFrame:StopMovingOrSizing()
	WorldMapFrame:ClearAllPoints()
	WorldMapFrame:SetAllPoints(UIParent)
	WorldMapFrame:SetScript("OnKeyDown", self.old_WorldMapFrame_OnKeyDown)
	WorldMapFrame:EnableMouse(false)
	WorldMapFrame:SetMovable(false)
	WorldMapFrame:SetResizable(false)
	self.old_WorldMapFrame_OnKeyDown = nil
	for i = 1, 1000 do
		local texture = _G["WorldMapOverlay" .. i]
		if not texture then
			break
		end
		texture:SetParent(WorldMapDetailFrame)
	end
	self.overlayHolder:Hide()
	BlackoutWorld:Show()
	WorldMapTooltip:SetFrameLevel(WorldMapFrame:GetFrameLevel() + 2)
	WorldMapFrameAreaLabel:Show()
	WorldMapButton:SetScript("OnEnter", nil)
	WorldMapButton:SetScript("OnLeave", nil)
	self.playerModel:SetModelScale(1)
	if WorldMapFrame:IsShown() then
		ToggleWorldMap()
		ToggleWorldMap()
	end
	Cartographer:RefreshSideTablet()
end

function Cartographer_LookNFeel:MODIFIER_STATE_CHANGED()
	if self.db.profile.locked then
		if IsAltKeyDown() then
			WorldMapFrame:EnableMouse(true)
			WorldMapFrame:EnableMouseWheel(true)
			WorldMapButton:EnableMouse(true)
			WorldMapMagnifyingGlassButton:EnableMouse(true)
			lockButton:SetChecked(false)
			local button = Cartographer:GetInstanceWorldMapButton()
			if button then
				button:EnableMouse(true)
			end
		else
			WorldMapFrame:EnableMouse(false)
			WorldMapFrame:EnableMouseWheel(false)
			WorldMapButton:EnableMouse(false)
			WorldMapMagnifyingGlassButton:EnableMouse(false)
			lockButton:SetChecked(true)
			local button = Cartographer:GetInstanceWorldMapButton()
			if button then
				button:EnableMouse(false)
			end
		end
	end
end

function Cartographer_LookNFeel:ShowWorldMapArrowFrame()
	--return self.hooks.ShowWorldMapArrowFrame(nil)
end

function Cartographer_LookNFeel:WorldMapButton_OnUpdate()
	WorldMapPlayer:SetScale(1)
end

function Cartographer_LookNFeel:CloseSpecialWindows()
	local found = self.hooks.CloseSpecialWindows()
	if self.db.profile.useEscape then
		if WorldMapFrame:IsShown() then
			ToggleWorldMap()
			return 1
		end
	end
	return found
end

function Cartographer_LookNFeel:WorldMapDetailFrame_CreateTexture(WorldMapDetailFrame, name, layer)
	if name and name:find("^WorldMapOverlay%d+$") then
		local frame = _G[name]
		
		frame:SetParent(self.overlayHolder)
	end
end

local newTexture, clearTextures
do
	local cache = {}
	local num = 12
	function newTexture(tex)
		local texture = next(cache)
		if texture then
			cache[texture] = nil
			texture:SetWidth(256)
			texture:SetHeight(256)
			texture:SetTexCoord(0, 1, 0, 1)
			texture:ClearAllPoints()
			texture:SetPoint(tex:GetPoint(1))
			texture:SetTexture(tex:GetTexture())
			texture:Show()
			return texture
		end
		num = num + 1
		texture = WorldMapDetailFrame:CreateTexture("WorldMapDetailTile" .. num, "BACKGROUND")
		texture:SetWidth(256)
		texture:SetHeight(256)
		texture:SetPoint(tex:GetPoint(1))
		texture:SetTexture(tex:GetTexture())
		return texture
	end
	function clearTextures()
		for i = 13, num do
			local tex = _G["WorldMapDetailTile" .. i]
			if tex:IsShown() then
				cache[tex] = true
				tex:Hide()
			end
		end
	end
end

local dirty = true
function Cartographer_LookNFeel:Cartographer_ChangeZone(zone)
	if dirty then
		for i = 1, 12 do
			local tex = _G["WorldMapDetailTile" .. i]
			local x = math.fmod(i-1, 4) * 256
			local y = -math.floor((i-1)/4) * 256
			tex:ClearAllPoints()
			tex:SetWidth(256)
			tex:SetHeight(256)
			tex:SetTexCoord(0, 1, 0, 1)
			tex:Show()
			--tex:SetPoint("TOPLEFT", WorldMapDetailFrame, "TOPLEFT", x, y)
		end
		WorldMapDetailTile1:SetPoint("BOTTOMRIGHT", WorldMapDetailFrame, "TOPLEFT", 256, -256)
		WorldMapDetailTile2:SetPoint("BOTTOMRIGHT", WorldMapDetailFrame, "TOPLEFT", 512, -256)
		WorldMapDetailTile3:SetPoint("BOTTOMLEFT", WorldMapDetailFrame, "TOPLEFT", 512, -256)
		WorldMapDetailTile4:SetPoint("BOTTOMLEFT", WorldMapDetailFrame, "TOPLEFT", 768, -256)
		WorldMapDetailTile5:SetPoint("TOPRIGHT", WorldMapDetailFrame, "TOPLEFT", 256, -256)
		WorldMapDetailTile6:SetPoint("TOPRIGHT", WorldMapDetailFrame, "TOPLEFT", 512, -256)
		WorldMapDetailTile7:SetPoint("TOPLEFT", WorldMapDetailFrame, "TOPLEFT", 512, -256)
		WorldMapDetailTile8:SetPoint("TOPLEFT", WorldMapDetailFrame, "TOPLEFT", 768, -256)
		WorldMapDetailTile9:SetPoint("TOPRIGHT", WorldMapDetailFrame, "TOPLEFT", 256, -512)
		WorldMapDetailTile10:SetPoint("TOPRIGHT", WorldMapDetailFrame, "TOPLEFT", 512, -512)
		WorldMapDetailTile11:SetPoint("TOPLEFT", WorldMapDetailFrame, "TOPLEFT", 512, -512)
		WorldMapDetailTile12:SetPoint("TOPLEFT", WorldMapDetailFrame, "TOPLEFT", 768, -512)
		clearTextures()
		dirty = false
	end
	if zone == "Warsong Gulch" then
		WorldMapDetailTile1:Hide()
		WorldMapDetailTile4:Hide()
		WorldMapDetailTile5:Hide()
		WorldMapDetailTile8:Hide()
		WorldMapDetailTile9:Hide()
		WorldMapDetailTile12:Hide()
		newTexture(WorldMapDetailTile1)
		newTexture(WorldMapDetailTile2)
		newTexture(WorldMapDetailTile3)
		newTexture(WorldMapDetailTile4)
		newTexture(WorldMapDetailTile5)
		newTexture(WorldMapDetailTile6)
		newTexture(WorldMapDetailTile7)
		newTexture(WorldMapDetailTile8)
		newTexture(WorldMapDetailTile9)
		newTexture(WorldMapDetailTile10)
		newTexture(WorldMapDetailTile11)
		newTexture(WorldMapDetailTile12)
		
		WorldMapDetailTile2:SetWidth(206)
		WorldMapDetailTile2:SetHeight(206)
		WorldMapDetailTile2:SetTexCoord(50/256, 1, 50/256, 1)
		
		WorldMapDetailTile6:SetWidth(206)
		WorldMapDetailTile6:SetTexCoord(50/256, 1, 0, 1)
		
		WorldMapDetailTile10:SetWidth(206)
		WorldMapDetailTile10:SetHeight(128)
		WorldMapDetailTile10:SetTexCoord(50/256, 1, 0, 128/256)
		
		WorldMapDetailTile3:SetWidth(181)
		WorldMapDetailTile3:SetHeight(206)
		WorldMapDetailTile3:SetTexCoord(0, 181/256, 50/256, 1)
		
		WorldMapDetailTile7:SetWidth(181)
		WorldMapDetailTile7:SetTexCoord(0, 181/256, 0, 1)
		
		WorldMapDetailTile11:SetWidth(181)
		WorldMapDetailTile11:SetHeight(128)
		WorldMapDetailTile11:SetTexCoord(0, 181/256, 0, 128/256)
		
		dirty = true
	elseif zone == "Arathi Basin" then
		WorldMapDetailTile1:Hide()
		WorldMapDetailTile4:Hide()
		WorldMapDetailTile5:Hide()
		WorldMapDetailTile8:Hide()
		WorldMapDetailTile9:Hide()
		WorldMapDetailTile10:Hide()
		WorldMapDetailTile11:Hide()
		WorldMapDetailTile12:Hide()
		newTexture(WorldMapDetailTile1)
		newTexture(WorldMapDetailTile2)
		newTexture(WorldMapDetailTile3)
		newTexture(WorldMapDetailTile4)
		newTexture(WorldMapDetailTile5)
		newTexture(WorldMapDetailTile6)
		newTexture(WorldMapDetailTile7)
		newTexture(WorldMapDetailTile8)
		newTexture(WorldMapDetailTile9)
		newTexture(WorldMapDetailTile10)
		newTexture(WorldMapDetailTile11)
		newTexture(WorldMapDetailTile12)
		
		WorldMapDetailTile2:SetWidth(191)
		WorldMapDetailTile2:SetHeight(136)
		WorldMapDetailTile2:SetTexCoord(65/256, 1, 120/256, 1)
		
		WorldMapDetailTile3:SetWidth(146)
		WorldMapDetailTile3:SetHeight(136)
		WorldMapDetailTile3:SetTexCoord(0, 146/256, 120/256, 1)
		
		WorldMapDetailTile6:SetWidth(191)
		WorldMapDetailTile6:SetHeight(206)
		WorldMapDetailTile6:SetTexCoord(65/256, 1, 0, 206/256)
		
		WorldMapDetailTile7:SetWidth(146)
		WorldMapDetailTile7:SetHeight(206)
		WorldMapDetailTile7:SetTexCoord(0, 146/256, 0, 206/256)
		dirty = true
	elseif zone == "Alterac Valley" then
		WorldMapDetailTile1:Hide()
		WorldMapDetailTile4:Hide()
		WorldMapDetailTile5:Hide()
		WorldMapDetailTile8:Hide()
		WorldMapDetailTile9:Hide()
		WorldMapDetailTile12:Hide()
		newTexture(WorldMapDetailTile1)
		newTexture(WorldMapDetailTile2)
		newTexture(WorldMapDetailTile3)
		newTexture(WorldMapDetailTile4)
		newTexture(WorldMapDetailTile5)
		newTexture(WorldMapDetailTile6)
		newTexture(WorldMapDetailTile7)
		newTexture(WorldMapDetailTile8)
		newTexture(WorldMapDetailTile9)
		newTexture(WorldMapDetailTile10)
		newTexture(WorldMapDetailTile11)
		newTexture(WorldMapDetailTile12)
		
		WorldMapDetailTile2:SetWidth(156)
		WorldMapDetailTile2:SetHeight(231)
		WorldMapDetailTile2:SetTexCoord(100/256, 1, 25/256, 1)
		
		WorldMapDetailTile6:SetWidth(156)
		WorldMapDetailTile6:SetTexCoord(100/256, 1, 0, 1)
		
		WorldMapDetailTile10:SetWidth(156)
		WorldMapDetailTile10:SetHeight(128)
		WorldMapDetailTile10:SetTexCoord(100/256, 1, 0, 128/256)
		
		WorldMapDetailTile3:SetWidth(100)
		WorldMapDetailTile3:SetHeight(231)
		WorldMapDetailTile3:SetTexCoord(0, 100/256, 25/256, 1)
		
		WorldMapDetailTile7:SetWidth(100)
		WorldMapDetailTile7:SetTexCoord(0, 100/256, 0, 1)
		
		WorldMapDetailTile11:SetWidth(100)
		WorldMapDetailTile11:SetHeight(128)
		WorldMapDetailTile11:SetTexCoord(0, 100/256, 0, 128/256)
		
		dirty = true
	elseif zone == "Eye of the Storm" then
		WorldMapDetailTile1:Hide()
		WorldMapDetailTile4:Hide()
		WorldMapDetailTile5:Hide()
		WorldMapDetailTile8:Hide()
		WorldMapDetailTile9:Hide()
		WorldMapDetailTile12:Hide()
		newTexture(WorldMapDetailTile1)
		newTexture(WorldMapDetailTile2)
		newTexture(WorldMapDetailTile3)
		newTexture(WorldMapDetailTile4)
		newTexture(WorldMapDetailTile5)
		newTexture(WorldMapDetailTile6)
		newTexture(WorldMapDetailTile7)
		newTexture(WorldMapDetailTile8)
		newTexture(WorldMapDetailTile9)
		newTexture(WorldMapDetailTile10)
		newTexture(WorldMapDetailTile11)
		newTexture(WorldMapDetailTile12)
		
		WorldMapDetailTile2:SetHeight(156)
		WorldMapDetailTile2:SetWidth(156)
		WorldMapDetailTile2:SetTexCoord(100/256, 1, 100/256, 1)
		WorldMapDetailTile6:SetWidth(156)
		WorldMapDetailTile6:SetTexCoord(100/256, 1, 0, 1)
		WorldMapDetailTile10:SetWidth(156)
		WorldMapDetailTile10:SetHeight(32)
		WorldMapDetailTile10:SetTexCoord(100/256, 1, 0, 32/256)
		
		WorldMapDetailTile3:SetHeight(156)
		WorldMapDetailTile3:SetWidth(100)
		WorldMapDetailTile3:SetTexCoord(0, 100/256, 100/256, 1)
		WorldMapDetailTile7:SetWidth(100)
		WorldMapDetailTile7:SetTexCoord(0, 100/256, 0, 1)
		WorldMapDetailTile11:SetWidth(100)
		WorldMapDetailTile11:SetHeight(32)
		WorldMapDetailTile11:SetTexCoord(0, 100/256, 0, 32/256)
		
		dirty = true
	end
	self:SetAlpha(self:GetAlpha())
end

function Cartographer_LookNFeel:GetAlpha()
	return self.db.profile.alpha
end

function Cartographer_LookNFeel:SetAlpha(value)
	self.db.profile.alpha = value
	if Cartographer:IsModuleActive(self) then
		WorldMapFrame:SetAlpha(1)
		WorldMapFrame:SetAlpha(value)
		if (GetCurrentMapZone() == 0 or cities[GetMapInfo()]) and self.db.profile.overlayAlpha > value then
			WorldMapDetailFrame:SetAlpha(self.db.profile.overlayAlpha)
		else
			WorldMapDetailFrame:SetAlpha(value)
		end
		for i = 13, 1000 do
			local tex = _G["WorldMapDetailTile" .. i]
			if tex then
				tex:SetAlpha(value)
			else
				break
			end
		end
		
		self.overlayHolder:SetAlpha(self.db.profile.overlayAlpha)
		for i,v in fake_ipairs(WorldMapFrame:GetChildren()) do
			if v:GetName() and (v:GetName():find("^Cartographer") or v:GetName():find("^Tablet20Detached")) then
				v:SetAlpha(self.db.profile.overlayAlpha)
			end
		end
		WorldMapButton:SetAlpha(self.db.profile.overlayAlpha)
		self.playerModel:SetAlpha(self.db.profile.overlayAlpha)
	end
end

function Cartographer_LookNFeel:GetOverlayAlpha()
	return self.db.profile.overlayAlpha
end

function Cartographer_LookNFeel:SetOverlayAlpha(value)
	self.db.profile.overlayAlpha = value
	if Cartographer:IsModuleActive(self) then
		if (GetCurrentMapZone() == 0 or cities[GetMapInfo()]) and value > self.db.profile.alpha then
			WorldMapDetailFrame:SetAlpha(value)
		else
			WorldMapDetailFrame:SetAlpha(self.db.profile.alpha)
		end
		for i = 13, 1000 do
			local tex = _G["WorldMapDetailTile" .. i]
			if tex then
				tex:SetAlpha(self.db.profile.alpha)
			else
				break
			end
		end
		self.overlayHolder:SetAlpha(value)
		for i,v in fake_ipairs(WorldMapFrame:GetChildren()) do
			if v:GetName() and (v:GetName():find("^Cartographer") or v:GetName():find("^Tablet20Detached")) then
				v:SetAlpha(value)
			end
		end
		WorldMapButton:SetAlpha(value)
		self.playerModel:SetAlpha(value)
	end
end

function Cartographer_LookNFeel:GetScale()
	return self.db.profile.scale
end

function Cartographer_LookNFeel:SetScale(value)
	self.db.profile.scale = value
	
	if Cartographer:IsModuleActive(self) then
		WorldMapFrame:SetScale(value)
		WorldMapTooltip:SetScale(self.db.profile.ttScale / value)
		Cartographer:RefreshSideTablet()
	end
end

function Cartographer_LookNFeel:GetTooltipScale()
	return self.db.profile.ttScale
end

function Cartographer_LookNFeel:SetTooltipScale(value)
	self.db.profile.ttScale = value
	
	if Cartographer:IsModuleActive(self) then
		WorldMapTooltip:SetScale(value / self.db.profile.scale)
	end
end

function Cartographer_LookNFeel:IsLocked()
	return self.db.profile.locked
end

function Cartographer_LookNFeel:ToggleLocked(value)
	if value == nil then
		value = not self.db.profile.locked
	end
	self.db.profile.locked = value
	if Cartographer:IsModuleActive(self) then
		WorldMapFrame:EnableMouse(not value)
		WorldMapFrame:EnableMouseWheel(not value)
		WorldMapButton:EnableMouse(not value)
		WorldMapMagnifyingGlassButton:EnableMouse(not value)
		local button = Cartographer:GetInstanceWorldMapButton()
		if button then
			button:EnableMouse(not value)
		end
	end
end

function Cartographer_LookNFeel:IsUsingEscape()
	return self.db.profile.useEscape
end

function Cartographer_LookNFeel:ToggleUsingEscape(value)
	if value == nil then
		value = not self.db.profile.useEscape
	end
	self.db.profile.useEscape = value
end

function Cartographer_LookNFeel:GetRealTooltipScale()
	return self.db.profile.ttScale / self.db.profile.scale
end

function Cartographer_LookNFeel:IsLargePlayerPOI()
	return self.db.profile.largePlayer
end

function Cartographer_LookNFeel:ToggleLargePlayerPOI(value)
	if value == nil then
		value = not self.db.profile.useEscape
	end
	self.db.profile.largePlayer = value
	
	self.playerModel:SetModelScale(value and 1.5 or 1)
end

function Cartographer_LookNFeel:OnProfileEnable()
	WorldMapFrame:SetPoint("CENTER", "UIParent", "CENTER", self.db.profile.x or 0, self.db.profile.y or 0)
	self:SetScale(self:GetScale())
	self:SetAlpha(self:GetAlpha())
	self:SetOverlayAlpha(self:GetOverlayAlpha())
	self:SetTooltipScale(self:GetTooltipScale())
	self:ToggleLocked(self:IsLocked())
	self:ToggleLargePlayerPOI(self:IsLargePlayerPOI())
end
